<template>
    <div class="label-create">
        <!-- <div class="row justify-start item-center q-pl-md-lg">
            <div class="col-12 q-ml-md-md font-18 text-black q-mt-lg">
                <q-btn flat no-caps @click="selectCurrentPage('default')">
                    <q-icon name="arrow_back" color="black" size="25px" />
                    <span class="font-18 helvetica-neue-medium q-pl-md">
                        {{ $t('button.back') }}
                    </span>
                </q-btn>
            </div>
        </div> -->

        <!-- title & save button -->
        <!-- <div class="row justify-center item-center">
            <div class="col-6 font-18 text-black q-mt-lg">
                {{ $t('preference.createRoles') }}
            </div>
            <div class="col-5 font-18 text-black q-mt-lg q-pl-md text-right">
                <q-btn
                    no-caps
                    color="green"
                    :label="$t('button.save')"
                    @click="createRole"
                />
            </div>
        </div> -->

        <div class="row justify-center item-center q-py-md">
            <div class="row item-center col-6 font-18 text-black q-mt-xs">
                <q-btn class="
                    q-pr-sm 
                    q-pl-lg-md 
                    q-pl-md-md 
                    q-pl-sm-md 
                    q-pl-xs-none" 
                    flat 
                    no-caps 
                    @click="selectCurrentPage('default')">
                    <q-icon name="arrow_back" color="black" size="25px" />
                </q-btn>
                <div class="label-title-container helvetica-neue-medium">
                    {{ $t('preference.createRoles') }}
                </div>
            </div>
            <div class="col-6 q-pr-md-xl font-18 text-black q-mt-xs text-right">
                <q-btn
                    no-caps
                    text-color="white"
                    class="button-save"
                    :label="$t('button.save')"
                    @click="createRole"
                />
            </div>
        </div>

        <!-- label -->
        <div class="row justify-center item-center">
            <div class="col-md-5 col-12 q-pl-md-xl q-mt-sm justify-center">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.rolesName') }}
                    <span class="text-ff0000 font-10" v-if="!state.roles.name">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    bottom-slots
                    :dense="dense"
                    v-model="state.roles.name"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div class="col-md-7 col-12 justify-between q-pr-md-xl q-mt-sm q-pl-lg-xl q-pl-md-xl q-pl-xs-none">
                <div class="row">
                    <p class="font-14 q-mb-md helvetica-neue-medium">
                        {{ $t('preference.roleColor') }}
                    </p>
                </div>
                <div class="row">
                    <div class="col-lg-2 col-md-3 col-xs-3 col-sm-3">
                        <div
                            class="
                                color-container
                                bg-666B72
                                items-center
                                row
                                justify-center
                                border-radius-10
                            "
                            :style="{
                                backgroundColor:
                                    state.roles?.color?.name ??
                                    state.roles.color
                            }"
                        >
                            <q-img
                                src="~assets/images/check.png"
                                width="20px"
                                height="20px"
                            />
                        </div>
                    </div>
                    <div class="col-lg-10 col-md-9 col-xs-9 col-sm-9">
                        <div
                            class="
                                q-ml-md q-mb-sm q-pa-md
                                color-container-mini
                                row
                                border-radius-10
                                pointer
                            "
                            :style="{
                                backgroundColor: color.name
                            }"
                            v-for="(color, index) in state.colors"
                            :key="'color-' + index"
                            @click="selectColor(color)"
                        ></div>
                    </div>
                </div>
            </div>
        </div>

        <!-- icons -->
        <div class="row justify-center item-center q-pt-md">
            <div class="col-11 justify-start">
                <p class="font-16 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.permission') }}
                    <span
                        class="text-ff0000 font-10"
                        v-if="!state.selectedIcon"
                    >
                        {{ $t('form.required') }}
                    </span>
                </p>
            </div>
            <div class="col-11 justify-between">
                <div class="row justify-between items-center">
                    <div
                        class="
                            row
                            justify-between
                            items-center
                            auto-assign
                            col-lg-3
                            col-md-3
                            col-sm-4
                            col-xs-4
                            q-ma-sm
                        "
                        v-for="(type, index) in state.permissionList"
                        :key="index"
                    >
                        <div class="col-12 col-md-6 font-16 row items-center">
                            {{ type.name }}
                        </div>

                        <q-toggle
                            size="xl"
                            v-model="type.value"
                            color="green"
                            :true-value="1"
                            :false-value="0"
                        />
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script lang="ts">
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    computed,
    watch,
    reactive,
    onMounted
} from 'vue';
import { MemberPermission } from 'src/services/enums/MemberPermission';

export default defineComponent({
    name: 'CreateRole',
    setup(props, { emit }) {
        let state = reactive({
            currentPage: 'default',
            roles: { name: '', color: '', permissions: '', totalMember: '' } as any,
            loadingState: ref(false),
            toggleValue: {} as any,
            permissionList: [] as any,
            lists: [] as any,
            permissionOrder: '',
            colors: [
                {
                    id: 1,
                    name: '#4586E1'
                },
                {
                    id: 2,
                    name: '#8A6FF0'
                },
                {
                    id: 3,
                    name: '#FF6700'
                },
                {
                    id: 4,
                    name: '#46C883'
                },
                {
                    id: 5,
                    name: '#FFBB46'
                },
                {
                    id: 6,
                    name: '#FA6EAD'
                },
                {
                    id: 7,
                    name: '#29C5CE'
                },
                {
                    id: 8,
                    name: '#F09253'
                },
                {
                    id: 9,
                    name: '#F4656B'
                },
                {
                    id: 10,
                    name: '#7393C2'
                },
                {
                    id: 11,
                    name: '#C784AF'
                },
                {
                    id: 12,
                    name: '#00949D'
                }
            ],
            icons: [
                {
                    id: 1,
                    name: 'nightlight'
                },
                {
                    id: 2,
                    name: 'people'
                },
                {
                    id: 3,
                    name: 'campaign'
                }
            ]
        });
        const store = useStore();

        const selectCurrentPage = (page: string) => {
            emit('update-page', page);
        };

        const selectColor = (color: any) => {
            state.roles.color = color.name;
        };
        const getRoles = () => {
            state.lists = MemberPermission;
            state.lists = Object.values(MemberPermission);

            if (state.lists) {
                state.lists.forEach((element: any) => {
                    let permission = {
                        name: element,
                        value: 0
                    };
                    state.permissionList.push(permission);
                });
            }
        };

        const createRole = async () => {
            /* console.log(state.roles) */
            if (store.state.role.permissions.role?.create) {
                state.lists = [];
                await state.permissionList.forEach((element: any) => {
                    if (element.value == 1) {
                        state.lists.push(element.name);
                    }
                });
                if (state.lists) {
                    let result = state.lists
                        .map((item: any) => {
                            return item;
                        })
                        .join(',');
                    if (state.roles.color?.name) {
                        state.roles.color = state.roles.color.name;
                    }

                    if (state.roles?.color === '') {
                        state.roles.color = '#666B72';
                    }

                    state.roles.permissions = result;
                    state.roles.permissions.toString();
                }
                await store.dispatch('role/create', state.roles);
                emit('update-page', state.currentPage);
            }
        };
        getRoles();
        return {
            state,
            dense: ref(true),
            createRole,
            MemberPermission,
            getRoles,
            selectColor,
            selectCurrentPage
        };
    }
});
</script>
